#!/usr/bin/env ruby

def is_numeric?(n) Integer n rescue false end

def run_script(script_number,mac,ssid,ip)
	script_name_list_file=File.new("/tmp/script_name_list", "r")
	scripts=script_name_list_file.read

	script_array=scripts.split("\n")

	if(script_array.at(script_number)!=nil)
		if(ip==nil)
			system("/karma/scripts/"+script_array[script_number],mac,ssid)
		else
			system("/karma/scripts/"+script_array[script_number],mac,ssid,ip)
		end
	else
		return false
	end
	
	return true
end
def switch_led(state)
	if(File.exists?("/proc/gpio/") && File.directory?("/proc/gpio/")):
		log=File.open("/tmp/status.log","a")
		if (state):
			value=1
		else
			value=0
		end
		log.close
		io = File.open("/proc/gpio/2_out", "w")
		io.print value
		io.close
		io = File.open("/proc/gpio/2_dir", "w")
		io.print value
		io.close
	else
		# kmod_gpio module not installed
	end
end
def get_mac_state()
	if(File.exists?("/tmp/mac_status")):
		state_file = File.open("/tmp/mac_status","r")
		state=state_file.readline
		return state
	else
		return 0
	end
end
def clear_mac_list()
	system("iwpriv", "ath0", "maccmd", "3")
end
def mac_off()
	state_file=File.open("/tmp/mac_status","w")
	state_file.print(0)
	state_file.close
	system("iwpriv", "ath0", "maccmd", "0")
end
def mac_white()
	state_file=File.open("/tmp/mac_status","w")
	state_file.print(1)
	state_file.close
	system("iwpriv", "ath0", "maccmd", "1")
end
def mac_black()
	state_file=File.open("/tmp/mac_status","w")
	state_file.print(2)
	state_file.close
	system("iwpriv", "ath0", "maccmd", "2")
end

def add_mac(mac)
	system("iwpriv", "ath0", "addmac", mac)
end
def kick_mac(mac)
	system("iwpriv", "ath0", "kickmac", mac)
end
def check_mac(mac)
	return (mac =~ /^((?:[0-9a-f]{2}:){5}[0-9a-f]{2})$/i)
end
def check_ssid(ssid)
	return ssid.length < 33 && ssid.length > 0;
end
def interface_exists()
	return (`iwconfig ath0 2>&1` =~ /No such device/)
end
def create_interface()
# using ` rather than system as system outputs messages to screen
	system("wlanconfig ath0 create wlandev wifi0 wlanmode master 2>&1 > /dev/null")
	#`wlanconfig ath0 create wlandev wifi0 wlanmode master > /dev/null`
end
def interface_down()
	system("ifconfig", "ath0", "down")
end
def interface_up()
	system("ifconfig", "ath0", "10.1.1.1", "up")
end
def is_interface_up()
	return (`ifconfig ath0` =~ /UP/)
end
def karma_on()
	system("iwpriv", "ath0", "karma", "1")
	switch_led(true)
end
def karma_off()
	system("iwpriv", "ath0", "karma", "0")
	switch_led(false)
end
def is_karam_on()
	return (`iwpriv ath0 get_karma` =~ /get_karma:1/)
end
def is_karma_blacklist()
	return (`iwpriv ath0 get_karma_bw` =~ /get_karma_bw:0/)
end
def karma_blacklist()
	system("iwpriv", "ath0", "karma_bw", "0")
end
def karma_whitelist()
	system("iwpriv", "ath0", "karma_bw", "1")
end
def add_ssid (ssid)
	system("iwpriv", "ath0", "addkarmassid", ssid)
end
def clear_ssid_list()
switch_led(true)
	system("iwpriv", "ath0", "clrkarmalist", "0")
end
